import type { ValidateFn } from '@poppinss/validator-lite';
import type { CredentialsConfig } from '../types/config.js';
import { Validator } from './validator.js';
export declare class Credentials<CredentialValues extends Record<string, any>> {
    #private;
    constructor(values: CredentialValues);
    static schema: {
        number: typeof import("@poppinss/validator-lite/build/src/schema/number.js").number;
        string: typeof import("@poppinss/validator-lite/build/src/schema/string.js").string;
        boolean: typeof import("@poppinss/validator-lite/build/src/schema/boolean.js").boolean;
        enum: typeof import("@poppinss/validator-lite/build/src/schema/oneOf.js").oneOf;
    };
    static rules<T extends {
        [key: string]: ValidateFn<unknown>;
    }>(schema: T): Validator<T>;
    static create<Schema extends {
        [key: string]: ValidateFn<unknown>;
    }>(schema: Schema, config?: CredentialsConfig): Promise<Credentials<{
        [K in keyof Schema]: ReturnType<Schema[K]>;
    }>>;
    get<K extends keyof CredentialValues>(key: K): CredentialValues[K];
    get<K extends keyof CredentialValues>(key: K, defaultValue: Exclude<CredentialValues[K], undefined>): Exclude<CredentialValues[K], undefined>;
    get(key: string): string | undefined;
    get(key: string, defaultValue: string): string;
}
