import fspath from 'node:path';
import fs from 'node:fs/promises';
export class FileSystem {
    async exists({ path }) {
        try {
            await fs.stat(path);
            return true;
        }
        catch {
            return false;
        }
    }
    async read({ path }) {
        const content = await fs.readFile(path, { encoding: 'utf-8' });
        return content;
    }
    async write({ path, data }) {
        const dirname = fspath.dirname(path);
        const dirnameExists = await this.exists({ path: dirname });
        if (!dirnameExists) {
            await fs.mkdir(dirname, { recursive: true });
        }
        await fs.writeFile(path, data, { encoding: 'utf-8' });
    }
    async erase({ path }) {
        await fs.unlink(path);
    }
}
